<?php

class Dataview extends Controller {

    function Dataview() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->library(array('table', 'pagination'));
        $this->load->model('dataviewmodel');
    }

    function tableselect() {
        if (isset ($this->session->userdata['tableNames'])) {
            $this->session->unset_userdata('tableNames');
        }
        $formName = $this->session->userdata('formName');
        if (ctype_alpha($formName)) {
            $possibleName = $formName;
        }
        else {
            $possibleName = substr($formName, 0, - 1);
        }
        $like = $possibleName."%";
        $possibleNamesA = array($possibleName, $possibleName."1", $possibleName."2", $possibleName.'Final');
        $tableNameArray = $this->dataviewmodel->tableNameList($like, $possibleNamesA);
        //form with drop down - listing temp tables in the selected form type
        $data['formTable'] = $this->_selectFileTable($tableNameArray, $formName);
        $data['formOpen'] = form_open("dataview/tableselectvalidate");
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] =
        'View Screened Data - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
        '</span></span>';
        $data['backLink'] = anchor('/dataentry/datascreening', 'Back', array('title' => 'Back to Select Table', 'class'
                                  => 'back'));
        $this->load->view('user/dataentry/simpleform', $data);
    }

    function tableselectvalidate() {
        $this->_validateselecttable();
        if ($this->form_validation->run() == FALSE) {
            $formName = $this->session->userdata('formName');
            if (ctype_alpha($formName)) {
                $possibleName = $formName;
            }
            else {
                $possibleName = substr($formName, 0, - 1);
            }
            $like = $possibleName."%";
            $possibleNamesA = array($possibleName, $possibleName."1", $possibleName."2", $possibleName.'Final');
            $tableNameArray = $this->dataviewmodel->tableNameList($like, $possibleNamesA);
            //form with drop down - listing temp tables in the selected form type
            $data['formTable'] = $this->_selectFileTable($tableNameArray, $formName);
            $data['formOpen'] = form_open("dataview/tableselectvalidate");
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] =
            'View Screened Data - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
            '</span></span>';
            $data['backLink'] = anchor('/dataentry/datascreening', 'Back', array('title' => 'Back to Select Form Type',
                                      'class' => 'back'));
            $this->load->view('user/dataentry/simpleform', $data);
        }
        else {
            $tableName1 = $this->input->post('tableName1');
            $tableNames['tableName1'] = $tableName1;
            $this->session->set_userdata('tableNames', $tableNames);
            if (isset ($this->session->userdata['countTotalRecords'])) {
                $this->session->unset_userdata('countTotalRecords');
            }
            redirect('dataview/viewall');
        }
    }

    function _selectFileTable($tableNameArray, $formName) {
        $tableName1 = set_value('tableName1');
        $tableName1DD = form_dropdown('tableName1', $tableNameArray, $tableName1);
        $tableNameHd = form_hidden('tableNameArray', $tableNameArray);
        $tableName1Err = form_error('tableName1');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $formTableA = array(array(), array('Table : ', $tableName1DD, $tableName1Err), array('', $tableNameHd), array('',
                           $submitButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateselecttable() {
        $this->form_validation->set_rules('tableName1', 'Table', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function viewall($offset = 0) {
        if (!isset ($this->session->userdata['tableNames'])) {
            redirect('dataview/tableselect');
        }
        $tableNames = $this->session->userdata('tableNames');
        $tableName1 = $tableNames['tableName1'];
        ////////////////////////////////////////
        $selectedPlotName = $this->session->userdata('selectedPlotName');
        $formName = $this->session->userdata('formName');
        $formType = $this->session->userdata('formType');
        if ($formType == 'Old') {
            $processData = $this->_processOld($formName, $selectedPlotName);
        }
        else {
            $processData = $this->_process($formName, $selectedPlotName);
        }
        $headerListA = $processData['headerListA'];
        $columnNameA = $processData['columnNameA'];
        ////////////////////////////////////////////////
        foreach ($columnNameA as $key => $value) {
            $columnListA[$key] = $value;
        }
        if (!isset ($this->session->userdata['countTotalRecords'])) {
            $getAllRecordsQuery = $this->dataviewmodel->getAllRecords($tableName1, $columnListA);
            $countTotalRecords = $getAllRecordsQuery->num_rows();
        }
        else {
            $countTotalRecords = $this->session->userdata('countTotalRecords');
        }
        if ($countTotalRecords > 0) {
            $limit = 30;
            $getRecordsLimitQuery = $this->dataviewmodel->getRecordsLimit($tableName1, $columnListA, $offset, $limit);
            $getRecordsLimitResult = $getRecordsLimitQuery->result_array();
            //offset - starting point for the current page
            $uri_segment = 3;
            $offset = $this->uri->segment($uri_segment);
            //generate pagination
            $config['base_url'] = site_url('dataview/viewall/');
            $config['total_rows'] = $countTotalRecords;
            $config['per_page'] = $limit;
            $config['uri_segment'] = $uri_segment;
            if ($countTotalRecords > 0 AND $limit > 0) {
                $pageCount = $countTotalRecords / $limit;
                $pageCount = ceil($pageCount);
                $config['last_link'] = "Last(".$pageCount.")>";
            }
            $this->pagination->initialize($config);
            $data['pagination'] = $this->pagination->create_links();
            //generate table data
            $tmpl = array('table_open' => '<table id="formtable">');
            $this->table->set_template($tmpl);
            $this->table->set_empty("&nbsp;");
            $headerListShift = $headerListA;
            array_unshift($headerListShift, "No.");
            $this->table->set_heading($headerListShift);
            $i = 0 + $offset;
            foreach ($getRecordsLimitResult as $limitRow) {
                $i =++$i;
                array_unshift($limitRow, $i);
                $this->table->add_row($limitRow);
            }
            $data['table'] = $this->table->generate();
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] =
            'View Screened Data - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
            '</span></span>'.'<h5 align=right>Total Records: '.$countTotalRecords.'</h5>';
            $data['backLink'] = anchor('/dataview/tableselect', 'Back', array('title' => 'Back to Select Form Type',
                                      'class' => 'back'));
            $this->load->view('treeforms/viewform', $data);
        }
        else {
            $data['table'] = "<h2>No Record Found!!</h2>";
            $data['pagination'] = "";
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] =
            'View Screened Data - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
            '</span></span>';
            $data['backLink'] = anchor('/dataview/tableselect', 'Back', array('title' => 'Back to Select Form Type',
                                      'class' => 'back'));
            $this->load->view('treeforms/viewform', $data);
        }
    }

    function _process($formName, $selectedPlotName) {
        $this->load->library('formlibrary');
        $fileName = base_url()."files/configfiles/".$formName."_".$selectedPlotName.".txt";
        $fileName = str_replace(" ", "", $fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);
        if ($formDetailResult == "Not Found") {
            echo "Configuration File Not Found  :  ".$fileName;
            die();
        }
        $this->load->library('gdelibrary');
        $processData = $this->gdelibrary->processData($formDetailResult);
        return $processData;
    }

    function _processOld($formName, $selectedPlotName) {
        $filterNameA = $filterHeaderA = $columnNameA = $headerListA = array();
        $tableName = $this->session->userdata('tableName');
        $this->load->library('formlibrary');
        $fileName = base_url()."files/configfiles/".$formName."_".$selectedPlotName."_".$tableName.".txt";
        $fileName = str_replace(" ", "", $fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);
        if ($formDetailResult == "Not Found") {
            echo "Configuration File Not Found  :  ".$fileName;
            die();
        }
        foreach ($formDetailResult as $formDetailRow) {
            if ($formDetailRow->ColumnType == 'Filter') {
                $filterResult[] = $formDetailRow;
            }
            else {
                $formResult[] = $formDetailRow;
            }
        }
        $this->load->library('oldgdelibrary');
        if (count($filterResult) > 0) {
            //if filters exist add filter columns first
            $processFilterData = $this->oldgdelibrary->processData($filterResult);
            $filterNameA = $processFilterData['columnNameA'];
            $filterHeaderA = $processFilterData['headerListA'];
        }
        $processData = $this->oldgdelibrary->processData($formResult);
        $columnNameA = $processData['columnNameA'];
        $headerListA = $processData['headerListA'];
        foreach ($columnNameA as $key => $value) {
            if (in_array($value, $filterNameA)) {
                //if the column name already exist in filters remove it from columnNameA and headerListA
                unset ($columnNameA[$key]);
                unset ($headerListA[$key]);
            }
        }
        $processData['headerListA'] = array_merge($filterHeaderA, $headerListA);
        $processData['columnNameA'] = array_merge($filterNameA, $columnNameA);
        return $processData;
    }

    /////////////Helper Function/////////////////
    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }
    ////////////////////////////////////////

}
