<?php

class Fileupload extends Controller {

    function Fileupload() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->library('filereader');
        $this->load->model('fileuploadmodel');
    }

    function menu() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $formTableA = array(array(''), array(anchor('/fileupload/csv', 'Upload a CSV file', array('title' =>
                           'Upload a CSV file', 'class' => 'forward'))), array(anchor('/fileupload/xls',
                           'Upload a XLS file', array('title' => 'Upload a XLS file', 'class' => 'forward'))), array(
                           anchor('/fileupload/tab', 'Upload a Tab file', array('title' => 'Upload a Tab file',
                           'class' => 'forward'))));
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Upload File - Select File Type ";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['table'] = $this->table->generate($formTableA);
        $data['backLink'] = "";
        $this->load->view('forms/simpleform', $data);
    }

    function csv() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $fileUploadErr = "";
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Upload CSV File";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open_multipart('fileupload/csvvalidate');
        $data['table'] = $this->_csvForm($fileUploadErr);
        $data['backLink'] = anchor('fileupload/menu/', 'Back - Upload File', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function csvvalidate() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $config['upload_path'] = './files/uploadfiles/';
        $config['allowed_types'] = 'csv';
        $config['max_size'] = '10240';
        $config['overwrite'] = 'TRUE';
        $this->load->library('upload', $config);
        $this->_validateCSV();
        if (($this->form_validation->run() == FALSE) && (!$this->upload->do_upload()) || ($this->form_validation->run()
           == FALSE) || (!$this->upload->do_upload())) {
            $fileUploadErr = $this->upload->display_errors('<p class="errorblock">', '</p>');
            $data['title'] = "Upload Data File";
            $data['contentTitle'] = "Upload CSV File";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open_multipart('fileupload/csvvalidate');
            $data['table'] = $this->_csvForm($fileUploadErr);
            $data['backLink'] = anchor('fileupload/menu/', 'Back - Upload File', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            $tableName = $this->input->post('tableNameDD');
            $hasHeader = $this->input->post('headerIncDD');
            $delimiter = $this->input->post('delimiter');
            $enclosure = "";
            $fileInfo = array('upload_file' => $this->upload->data());
            $fileName = $fileInfo['upload_file']['orig_name'];
            $filePath = "./files/uploadfiles/".$fileName;
            $headers = $this->filereader->csvHeader($filePath, $hasHeader, $delimiter, $enclosure);
            $fileUploadInfo['filePath'] = $filePath;
            $fileUploadInfo['tableName'] = $tableName;
            $fileUploadInfo['hasHeader'] = $hasHeader;
            $fileUploadInfo['delimiter'] = $delimiter;
            $fileUploadInfo['headers'] = $headers;
            $this->session->set_userdata('fileUploadInfo', $fileUploadInfo);
            redirect('fileupload/csvpair');
        }
    }

    function _csvForm($fileUploadErr) {
        $tableNameDDA = $this->fileuploadmodel->getTableList("");
        $headerIncDDA = array('default' => 'Select', 'yes' => 'Yes', 'no' => 'No');
        $delimiterTbxA = array('name' => 'delimiter', 'id' => 'delimiter', 'size' => '10', 'value' => ',');
        $fileUploadA = array('name' => 'userfile', 'id' => 'userfile', 'size' => '20');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $tableNameDD = form_dropdown('tableNameDD', $tableNameDDA);
        $headerIncDD = form_dropdown('headerIncDD', $headerIncDDA);
        $delimiterTbx = form_input($delimiterTbxA);
        $fileUpload = form_upload($fileUploadA);
        $submitButton = form_button($submitButtonA);
        $tableNameDDErr = form_error('tableNameDD');
        $headerIncDDErr = form_error('headerIncDD');
        $delimiterErr = form_error('delimiterTbx');
        $formTableA = array(array(''), array('Select Table : ', $tableNameDD, $tableNameDDErr), array(
                           'Header Included : ', $headerIncDD, $headerIncDDErr), array('Delimiter :', $delimiterTbx, $delimiterErr
                           ), array('File(*.csv) :', $fileUpload, $fileUploadErr), array('', '<p style="text-align:center;">'.$submitButton
                           .'</p>'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateCSV() {
        $this->form_validation->set_rules('tableNameDD', 'Table', 'callback_dropdown_check');
        $this->form_validation->set_rules('headerIncDD', 'Header Info', 'callback_dropdown_check');
        $this->form_validation->set_rules('delimiter', 'Delimiter', 'required');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function csvpair() {
        if (!isset ($this->session->userdata['fileUploadInfo'])) {
            redirect('fileupload/csv');
        }
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $data['table'] = $this->_csvpairForm($tableName, $headers);
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Pair Columns";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open('fileupload/uploadcsv');
        $data['backLink'] = anchor('fileupload/csv/', 'Back - Upload File', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function _csvpairForm($tableName, $headers) {
        $tableColumnA = $this->fileuploadmodel->getTableColumns($tableName);
        $keepDefault = array("keepDefault" => "Keep Default");
        $headerDDA['keepDefault'] = "Keep Default";
        foreach ($headers as $id => $val) {
            $headerDDA[$id] = $val;
        }
        $this->table->set_empty("");
        $this->table->set_heading('<u>Table Columns</u>', '<u>File Headers</u>');
        foreach ($tableColumnA as $key => $value) {
            $headerDD = form_dropdown($key, $headerDDA);
            $this->table->add_row($key." : ", $headerDD);
        }
        $this->table->add_row("<br />");
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $this->table->add_row("", $submitButton);
        $formTable = $this->table->generate();
        return $formTable;
    }

    function uploadcsv() {
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $filePath = $fileUploadInfo['filePath'];
        $hasHeader = $fileUploadInfo['hasHeader'];
        $delimiter = $fileUploadInfo['delimiter'];
        $tableColumnA = $this->fileuploadmodel->getTableColumns($tableName);
        foreach ($tableColumnA as $key => $value) {
            $columns[$key] = $this->input->post($key);
        }
        $readData = $this->filereader->csvReader($filePath, $hasHeader, $delimiter, $columns);
        $uploadStatus = $this->fileuploadmodel->uploadToTable($tableName, $readData);
        if ($uploadStatus == "Done") {
            $data['table'] = '<div class="success">Data Uploaded Successfully.</div>';
        }
        else {
            $data['table'] = '<div class="error">Error Occured while Uploading.</div>';
        }
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "CSV Upload";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['backLink'] = anchor('fileupload/menu/', 'Back - Upload File', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function xls() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $fileUploadErr = "";
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Upload XLS File";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open_multipart('fileupload/xlsvalidate');
        $data['table'] = $this->_xlsForm($fileUploadErr);
        $data['backLink'] = anchor('fileupload/menu/', 'Back - Upload File', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function xlsvalidate() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $config['upload_path'] = './files/uploadfiles/';
        $config['allowed_types'] = 'xls';
        $config['max_size'] = '10240';
        $config['overwrite'] = 'TRUE';
        $this->load->library('upload', $config);
        $this->_validateTab();
        if (($this->form_validation->run() == FALSE) && (!$this->upload->do_upload()) || ($this->form_validation->run()
           == FALSE) || (!$this->upload->do_upload())) {
            $fileUploadErr = $this->upload->display_errors('<p class="errorblock">', '</p>');
            $data['title'] = "Upload Tab Data File";
            $data['contentTitle'] = "Upload XLS File";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open_multipart('fileupload/xlsvalidate');
            $data['table'] = $this->_xlsForm($fileUploadErr);
            $data['backLink'] = anchor('fileupload/menu/', 'Back - Upload File', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            $hasHeader = $this->input->post('headerIncDD');
            $tableName = $this->input->post('tableNameDD');
            $sheet = $this->input->post('sheet');
            $fileInfo = array('upload_file' => $this->upload->data());
            $fileName = $fileInfo['upload_file']['orig_name'];
            $filePath = "./files/uploadfiles/".$fileName;
            $this->load->library('filereader');
            $headers = $this->filereader->xlsHeader($filePath, $hasHeader, $sheet);
            $fileUploadInfo['filePath'] = $filePath;
            $fileUploadInfo['tableName'] = $tableName;
            $fileUploadInfo['hasHeader'] = $hasHeader;
            $fileUploadInfo['headers'] = $headers;
            $fileUploadInfo['sheet'] = $sheet;
            $this->session->set_userdata('fileUploadInfo', $fileUploadInfo);
            redirect('fileupload/xlspair');
        }
    }

    function _xlsForm() {
        $tableNameDDA = $this->fileuploadmodel->getTableList("");
        $headerIncDDA = array('default' => 'Select', 'yes' => 'Yes', 'no' => 'No');
        $sheetTbxA = array('name' => 'sheet', 'id' => 'sheet', 'size' => '10', 'value' => 'All');
        $fileUploadA = array('name' => 'userfile', 'id' => 'userfile', 'size' => '20');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $tableNameDD = form_dropdown('tableNameDD', $tableNameDDA);
        $headerIncDD = form_dropdown('headerIncDD', $headerIncDDA);
        $sheetTbx = form_input($sheetTbxA);
        $fileUpload = form_upload($fileUploadA);
        $submitButton = form_button($submitButtonA);
        $tableNameDDErr = form_error('tableNameDD');
        $headerIncDDErr = form_error('headerIncDD');
        $sheetTbxErr = form_error('sheet');
        $formTableA = array(array(''), array('Select Table : ', $tableNameDD, $tableNameDDErr), array(
                           'Header Included : ', $headerIncDD, $headerIncDDErr), array(
                           'Sheets(All or Sheet No.) : ', $sheetTbx, $sheetTbxErr), array('File(*.xls) :', $fileUpload), array('',
                           '<p style="text-align:center;">'.$submitButton.'</p>'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateXLS() {
        $this->form_validation->set_rules('tableNameDD', 'Table', 'callback_dropdown_check');
        $this->form_validation->set_rules('headerIncDD', 'Header Info', 'callback_dropdown_check');
        $this->form_validation->set_rules('sheet', 'Sheet', 'required|trim');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function xlspair() {
        if (!isset ($this->session->userdata['fileUploadInfo'])) {
            redirect('fileupload/xls');
        }
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $data['table'] = $this->_xlspairForm($tableName, $headers);
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Pair Columns";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open('fileupload/uploadxls');
        $data['backLink'] = anchor('fileupload/xls/', 'Back - Upload XLS File', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function _xlspairForm($tableName, $headers) {
        $tableColumnA = $this->fileuploadmodel->getTableColumns($tableName);
        $keepDefault = array("keepDefault" => "Keep Default");
        $headerDDA['keepDefault'] = "Keep Default";
        foreach ($headers as $id => $val) {
            $headerDDA[$id] = $val;
        }
        $this->table->set_empty("");
        $this->table->set_heading('<u>Table Columns</u>', '<u>File Headers</u>');
        foreach ($tableColumnA as $key => $value) {
            $headerDD = form_dropdown($key, $headerDDA);
            $this->table->add_row($key." : ", $headerDD);
        }
        $this->table->add_row("<br />");
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $this->table->add_row("", $submitButton);
        $formTable = $this->table->generate();
        return $formTable;
    }

    function uploadxls() {
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $filePath = $fileUploadInfo['filePath'];
        $hasHeader = $fileUploadInfo['hasHeader'];
        $sheet = $fileUploadInfo['sheet'];
        $tableColumnA = $this->fileuploadmodel->getTableColumns($tableName);
        foreach ($tableColumnA as $key => $value) {
            $columns[$key] = $this->input->post($key);
        }
        $readData = $this->filereader->xlsReader($filePath, $hasHeader, $columns,$sheet);
        $uploadStatus = $this->fileuploadmodel->uploadToTable($tableName, $readData);
        if ($uploadStatus == "Done") {
            $data['table'] = '<div class="success">Data Uploaded Successfully.</div>';
        }
        else {
            $data['table'] = '<div class="error">Error Occured while Uploading.</div>';
        }
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "XLS Upload";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['backLink'] = anchor('fileupload/menu/', 'Back - Upload File', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function tab() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $fileUploadErr = "";
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Upload Tab File";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open_multipart('fileupload/tabvalidate');
        $data['table'] = $this->_tabForm($fileUploadErr);
        $data['backLink'] = anchor('fileupload/menu/', 'Back - Upload File', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function tabvalidate() {
        if (isset ($this->session->userdata['fileUploadInfo'])) {
            $this->session->unset_userdata('fileUploadInfo');
        }
        $config['upload_path'] = './files/uploadfiles/';
        $config['allowed_types'] = 'txt';
        $config['max_size'] = '10240';
        $config['overwrite'] = 'TRUE';
        $this->load->library('upload', $config);
        $this->_validateTab();
        if (($this->form_validation->run() == FALSE) && (!$this->upload->do_upload()) || ($this->form_validation->run()
           == FALSE) || (!$this->upload->do_upload())) {
            $fileUploadErr = $this->upload->display_errors('<p class="errorblock">', '</p>');
            $data['title'] = "Upload Data File";
            $data['contentTitle'] = "Upload Tab File";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open_multipart('fileupload/tabvalidate');
            $data['table'] = $this->_tabForm($fileUploadErr);
            $data['backLink'] = anchor('fileupload/menu/', 'Back - Upload File', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            $tableName = $this->input->post('tableNameDD');
            $hasHeader = $this->input->post('headerIncDD');
            $delimiter = "\t";
            $enclosure = "";
            $fileInfo = array('upload_file' => $this->upload->data());
            $fileName = $fileInfo['upload_file']['orig_name'];
            $filePath = "./files/uploadfiles/".$fileName;
            $headers = $this->filereader->csvHeader($filePath, $hasHeader, $delimiter, $enclosure);
            $fileUploadInfo['filePath'] = $filePath;
            $fileUploadInfo['tableName'] = $tableName;
            $fileUploadInfo['hasHeader'] = $hasHeader;
            $fileUploadInfo['delimiter'] = $delimiter;
            $fileUploadInfo['headers'] = $headers;
            $this->session->set_userdata('fileUploadInfo', $fileUploadInfo);
            redirect('fileupload/tabpair');
        }
    }

    function _tabForm($fileUploadErr) {
        $tableNameDDA = $this->fileuploadmodel->getTableList("");
        $headerIncDDA = array('default' => 'Select', 'yes' => 'Yes', 'no' => 'No');
        $fileUploadA = array('name' => 'userfile', 'id' => 'userfile', 'size' => '20');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $tableNameDD = form_dropdown('tableNameDD', $tableNameDDA);
        $headerIncDD = form_dropdown('headerIncDD', $headerIncDDA);
        $fileUpload = form_upload($fileUploadA);
        $submitButton = form_button($submitButtonA);
        $tableNameDDErr = form_error('tableNameDD');
        $headerIncDDErr = form_error('headerIncDD');
        $formTableA = array(array(''), array('Select Table : ', $tableNameDD, $tableNameDDErr), array(
                           'Header Included : ', $headerIncDD, $headerIncDDErr), array('File(*.txt) :', $fileUpload, $fileUploadErr
                           ), array('', '<p style="text-align:center;">'.$submitButton.'</p>'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateTab() {
        $this->form_validation->set_rules('tableNameDD', 'Table', 'callback_dropdown_check');
        $this->form_validation->set_rules('headerIncDD', 'Header Info', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function tabpair() {
        if (!isset ($this->session->userdata['fileUploadInfo'])) {
            redirect('fileupload/tab');
        }
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $data['table'] = $this->_csvpairForm($tableName, $headers);
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Pair Columns";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open('fileupload/uploadtab');
        $data['backLink'] = anchor('fileupload/tab/', 'Back - Upload File', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function _tabpairForm($tableName, $headers) {
        $tableColumnA = $this->fileuploadmodel->getTableColumns($tableName);
        $keepDefault = array("keepDefault" => "Keep Default");
        $headerDDA['keepDefault'] = "Keep Default";
        foreach ($headers as $id => $val) {
            $headerDDA[$id] = $val;
        }
        $this->table->set_empty("");
        $this->table->set_heading('<u>Table Columns</u>', '<u>File Headers</u>');
        foreach ($tableColumnA as $key => $value) {
            $headerDD = form_dropdown($key, $headerDDA);
            $this->table->add_row($key." : ", $headerDD);
        }
        $this->table->add_row("<br />");
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $this->table->add_row("", $submitButton);
        $formTable = $this->table->generate();
        return $formTable;
    }

    function uploadtab() {
        $fileUploadInfo = $this->session->userdata('fileUploadInfo');
        $tableName = $fileUploadInfo['tableName'];
        $headers = $fileUploadInfo['headers'];
        $filePath = $fileUploadInfo['filePath'];
        $hasHeader = $fileUploadInfo['hasHeader'];
        $delimiter = $fileUploadInfo['delimiter'];
        $tableColumnA = $this->fileuploadmodel->getTableColumns($tableName);
        foreach ($tableColumnA as $key => $value) {
            $columns[$key] = $this->input->post($key);
        }
        $readData = $this->filereader->csvReader($filePath, $hasHeader, $delimiter, $columns);
        $uploadStatus = $this->fileuploadmodel->uploadToTable($tableName, $readData);
        if ($uploadStatus == "Done") {
            $data['table'] = '<div class="success">Data Uploaded Successfully.</div>';
        }
        else {
            $data['table'] = '<div class="error">Error Occured while Uploading.</div>';
        }
        $data['title'] = "Upload Data File";
        $data['contentTitle'] = "Tab Upload";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['backLink'] = anchor('fileupload/menu/', 'Back - Upload File', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }

}
