<?php

class Forms extends Controller {

    function Forms() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->model('configmodel');
        global $databaseName;
        $databaseName = $this->session->userdata('selectedPlotName');
    }

    function formtype() {
        if (isset ($this->session->userdata['formType'])) {
            $this->session->unset_userdata('formType');
        }
        if (isset ($this->session->userdata['formName'])) {
            $this->session->unset_userdata('formName');
        }
        if (isset ($this->session->userdata['tableName'])) {
            $this->session->unset_userdata('tableName');
        }
        $formTableA = array(array(''), array(anchor('/forms/formname', 'Configure New Form', array('title' =>
                           'Configure form for new data entry', 'class' => 'forward'))), array(anchor(
                           '/forms/formname/Old', 'Configure Old Form', array('title' => 'Configure form for re-census',
                           'class' => 'forward'))),);
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Select Form Type";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['table'] = $this->table->generate($formTableA);
        $data['backLink'] = "";
        $this->load->view('forms/simpleform', $data);
    }

    function formname($formType = 'New') {
        if (isset ($this->session->userdata['formName'])) {
            $this->session->unset_userdata('formName');
        }
        if (isset ($this->session->userdata['tableName'])) {
            $this->session->unset_userdata('tableName');
        }
        $this->session->set_userdata('formType', $formType);
        $message = '';
        $data['title'] = "Configuration Form";
        if ($formType == 'Old') {
            $data['contentTitle'] = "Select Form Name - Old Form";
        }
        else {
            $data['contentTitle'] = "Select Form Name - New Form";
        }
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("forms/formnamevalidate");
        $data['table'] = $this->_selectFormNameTable($message, $formType);
        $data['backLink'] = anchor('forms/formtype/', 'Back - Form Type', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function formnamevalidate() {
        global $databaseName;
        $formNameTbx = $this->input->post('formNameTbx');
        $formType = $this->session->userdata('formType');
        if (!empty ($formNameTbx)) {
            $checkFormName = $this->configmodel->checkFormName($formNameTbx, $databaseName);
            //return the form type
            if ($checkFormName !== 'No') {
                $message = "<p class='errorblock'>Form name already exist in ".$checkFormName.
                " forms, choose another name.</p>";
            }
            else {
                $message = "";
            }
            $this->_validateFormName('textBox');
            $formName = $formNameTbx;
        }
        else {
            $message = "";
            $this->_validateFormName('dropDown');
            $formName = $this->input->post('formNameDD');
        }
        if ($this->form_validation->run() == FALSE || $message != "") {
            $data['title'] = "Configuration Form";
            if ($formType == 'Old') {
                $data['contentTitle'] = "Select Form Name - Old Form";
            }
            else {
                $data['contentTitle'] = "Select Form Name - New Form";
            }
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("forms/formnamevalidate");
            $data['backLink'] = anchor('forms/formtype/', 'Back - Form Type', array('class' => 'back'));
            $data['table'] = $this->_selectFormNameTable($message, $formType);
            $this->load->view('forms/simpleform', $data);
        }
        else {
            $this->session->set_userdata('formName', $formName);
            if ($formType == 'Old') {
                redirect('forms/addcolumnold');
            }
            else {
                redirect('forms/addcolumn');
            }
        }
    }

    function _selectFormNameTable($message, $formType) {
        $formName = set_value('formNameTbx');
        $databaseName = $this->session->userdata('selectedPlotName');
        $formNameDDA = $this->configmodel->getFormNameList($databaseName, $formType);
        $formNameTbxA = array('name' => 'formNameTbx', 'id' => 'formNameTbx', 'size' => '20', 'maxlength' => '40',
                             'value' => $formName);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $formNameDD = form_dropdown('formNameDD', $formNameDDA);
        $formNameTbx = form_input($formNameTbxA);
        $submitButton = form_button($submitButtonA);
        $formNameDDErr = form_error('formNameDD');
        $formNameTbxErr = form_error('formNameTbx');
        if ($formNameTbxErr == "") {
            $formNameTbxErr = " (Alphabetical Characters Only)";
        }
        $formTableA = array(array(), array('Select Form : ', $formNameDD, $formNameDDErr), array('OR', '', $message),
                           array('Create New : ', $formNameTbx, $formNameTbxErr), array('',
                           '<p style="text-align:center;">'.$submitButton.'</p>'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateFormName($columnType) {
        if ($columnType == 'dropDown') {
            $this->form_validation->set_rules('formNameDD', 'Form Name', 'callback_dropdown_check');
        }
        else {
            $this->form_validation->set_rules('formNameTbx', 'Form Name', 'required|alpha|max_length[40]');
        }
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function addcolumn() {
        if (!isset ($this->session->userdata['formName']) || !isset ($this->session->userdata['formType'])) {
            redirect('forms/formtype');
        }
        global $databaseName;
        $formName = $this->session->userdata('formName');
        $formType = 'New';
        $plotColumnQuery = $this->configmodel->getDataByFormName($databaseName, $formName, $formType);
        $this->table->set_empty("&nbsp;");
        if ($plotColumnQuery->num_rows() > 0) {
            $this->table->set_heading('Number', 'Column', 'Action');
            $plotColumnResult = $plotColumnQuery->result();
            foreach ($plotColumnResult as $plotColumnRow) {
                $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
                $attributesArray = explode("\t", $plotColumnRow->Attributes);
                $columnHeader = $attributesArray[0];
                $this->table->add_row($plotColumnRow->ColumnNumber, $columnHeader, anchor('forms/deleteColumn/column/'.$dataEntryConfigID,
                                     'delete', array('class' => 'delete', 'onclick' =>
                                     "return confirm('Are you sure, you want to delete this record?')")));
            }
        }
        else {
            $this->table->add_row('No Columns Added Yet. Please Click "Add a New Column".');
        }
        $data['table'] = $this->table->generate();
        //Add a button to Add New Column
        $addLink = anchor('forms/selectcolumntype/', 'Add a New Column', array('class' => 'add'));
        if ($plotColumnQuery->num_rows() > 0) {
            $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/sortlist/', 'Rearrange Columns', array('class' =>
                                                           'update'))."&nbsp;&nbsp;&nbsp;".anchor('newplant/createform/',
                                                           'Preview Form', array('class' => 'view', 'target' => '_blank'
                                                           ))."<br />".anchor('forms/createconfigfile/',
                                                           'Create Config File For Single Data Entry', array('class' =>
                                                           'write'))."<br />".anchor('forms/createdoubleconfigfile/',
                                                           'Create Config Files For Double Data Entry', array('class' =>
                                                           'write'));
        }
        $data['addLink'] = $addLink;
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "List of Columns - ".$formName;
        $data['formHeading'] = "";
        $this->load->view('forms/columnlist', $data);
    }

    function addcolumnold() {
        if (!isset ($this->session->userdata['formName']) || !isset ($this->session->userdata['formType'])) {
            redirect('forms/formtype');
        }
        global $databaseName;
        $formName = $this->session->userdata('formName');
        $formType = 'Old';
        $columnRowCount = 0;
        $filterRowCount = 0;
        $plotColumnQuery = $this->configmodel->getDataByFormName($databaseName, $formName, $formType);
        //$filterQuery =  $this->configmodel->getFilterDataByFormName($databaseName,$formName,$formType);
        $this->table->set_empty("&nbsp;");
        if ($plotColumnQuery->num_rows() > 0) {
            $this->table->set_heading('Number', 'Column', 'Column Type', 'Action');
            $plotColumnResult = $plotColumnQuery->result();
            foreach ($plotColumnResult as $plotColumnRow) {
                $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
                $attributesArray = explode("\t", $plotColumnRow->Attributes);
                $columnType = $plotColumnRow->ColumnType;
                $tableName = $plotColumnRow->TableName;
                if ($columnType !== 'Filter') {
                    if ($columnType !== 'Old') {
                        $columnType = 'New';
                    }
                    $columnHeader = $attributesArray[0];
                    $this->table->add_row($plotColumnRow->ColumnNumber, $columnHeader, $columnType, anchor(
                                         'forms/deleteColumn/column/'.$dataEntryConfigID, 'delete', array('class' =>
                                         'delete', 'onclick' =>
                                         "return confirm('Are you sure, you want to delete this record?')")));
                    $columnRowCount++;
                }
            }
            if ($columnRowCount == 0) {
                $this->table->clear();
                $this->table->add_row('No columns added yet. Please Click "Add New Column or Add Old Column".');
            }
            $data['table'] = $this->table->generate();
            $this->table->clear();
            $this->table->set_heading('Number', 'Column', 'Column Type', 'Action');
            foreach ($plotColumnResult as $plotColumnRow) {
                $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
                $attributesArray = explode("\t", $plotColumnRow->Attributes);
                $columnType = $plotColumnRow->ColumnType;
                $tableName = $plotColumnRow->TableName;
                if ($columnType == 'Filter') {
                    $columnHeader = $attributesArray[0];
                    $this->table->add_row($plotColumnRow->ColumnNumber, $columnHeader, $columnType, anchor(
                                         'forms/deleteColumn/filter/'.$dataEntryConfigID, 'delete', array('class' =>
                                         'delete', 'onclick' =>
                                         "return confirm('Are you sure, you want to delete this record?')")));
                    $filterRowCount++;
                }
            }
            if ($filterRowCount == 0) {
                $this->table->clear();
                $this->table->add_row('No filter added yet. To add click "Add Data Filter".');
            }
            $data['table1'] = "<h3><u>Data Filters</u></h3>".$this->table->generate();
            $this->session->set_userdata('tableName', $tableName);
        }
        else {
            $tableName = "";
            if (isset ($this->session->userdata['tableName'])) {
                $tableName = $this->session->userdata['tableName'];
            }
            if ($tableName !== "") {
                $this->table->add_row(
                                     'No columns added yet. To add click "Add a New Column, Add Old Column or Add Data Filter".'
                                     );
            }
            else {
                $this->table->add_row('No view table is selected yet. Please click "Select a View Table".');
            }
            $data['table'] = $this->table->generate();
            $data['table1'] = "";
        }
        //Add a button to Add New Column
        if ($tableName !== "") {
            //Add a button to Add New Column
            $addLink = anchor('forms/selectcolumntype/', 'Add New Column', array('class' => 'add'))."&nbsp;&nbsp;&nbsp;"
                             .anchor('addoldcolumns/selectcolumns', 'Add Old Column', array('class' => 'add')).
                             "<br /><br />".anchor('addoldcolumns/selectcolumns/filter', 'Add Data Filter', array(
                             'class' => 'add'));
            if ($columnRowCount > 0 && $filterRowCount > 0) {
                $addLink = anchor('forms/selectcolumntype/', 'Add a New Column', array('class' => 'add')).
                                 "&nbsp;&nbsp;&nbsp;".anchor('addoldcolumns/selectcolumns', 'Add Old Columns', array(
                                 'class' => 'add'))."&nbsp;&nbsp;&nbsp;".anchor('forms/sortlist/old',
                                 'Rearrange Columns', array('class' => 'update'))."&nbsp;&nbsp;&nbsp;".anchor(
                                 'oldform/preview/', 'Preview Form', array('class' => 'view', 'target' => '_blank')).
                                 "<br />".anchor('forms/createconfigfile/', 'Create Config File For Single Data Entry',
                                 array('class' => 'write'))."<br />".anchor('forms/createdoubleconfigfile/',
                                 'Create Config Files For Double Data Entry', array('class' => 'write'))."<br /><br />".
                                 anchor('addoldcolumns/selectcolumns/filter', 'Add Data Filters', array('class' => 'add'
                                 ))."&nbsp;&nbsp;&nbsp;".anchor('forms/sortfilter/', 'Rearrange Filters', array('class'
                                 => 'update'));
            }
            elseif ($columnRowCount > 0 && $filterRowCount == 0) {
                $addLink = anchor('forms/selectcolumntype/', 'Add a New Column', array('class' => 'add')).
                                 "&nbsp;&nbsp;&nbsp;".anchor('addoldcolumns/selectcolumns', 'Add Old Columns', array(
                                 'class' => 'add'))."&nbsp;&nbsp;&nbsp;".anchor('forms/sortlist/old',
                                 'Rearrange Columns', array('class' => 'update'))."&nbsp;&nbsp;&nbsp;".anchor(
                                 'oldform/createform/', 'Preview Form', array('class' => 'view', 'target' => '_blank')).
                                 "<br />".anchor('forms/createconfigfile/', 'Create Config File For Single Data Entry',
                                 array('class' => 'write'))."<br />".anchor('forms/createdoubleconfigfile/',
                                 'Create Config Files For Double Data Entry', array('class' => 'write'))."<br /><br />".
                                 anchor('addoldcolumns/selectcolumns/filter', 'Add Data Filters', array('class' => 'add'
                                 ));
            }
            elseif ($columnRowCount == 0 && $filterRowCount > 0) {
                $addLink = anchor('forms/selectcolumntype/', 'Add a New Column', array('class' => 'add')).
                                 "&nbsp;&nbsp;&nbsp;".anchor('addoldcolumns/selectcolumns', 'Add Old Columns', array(
                                 'class' => 'add'))."<br /><br />".anchor('addoldcolumns/selectcolumns/filter',
                                 'Add Data Filters', array('class' => 'add'))."&nbsp;&nbsp;&nbsp;".anchor(
                                 'forms/sortfilter/', 'Rearrange Filters', array('class' => 'update'));
            }
        }
        else {
            $addLink = anchor('forms/selecttable/', 'Select the View Table', array('class' => 'add'));
        }
        $data['addLink'] = $addLink;
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "List of Columns - ".$formName;
        $data['formHeading'] = "";
        $this->load->view('forms/columnlistold', $data);
    }

    function selecttable() {
        if (isset ($this->session->userdata['tableName'])) {
            $this->session->unset_userdata('tableName');
        }
        $formName = $this->session->userdata('formName');
        $formType = 'Old';
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Select View Table - ".$formName;
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("forms/selecttablevalidate");
        $data['table'] = $this->_selectTableTable();
        $data['backLink'] = anchor('forms/addcolumnold/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function selecttablevalidate() {
        if (isset ($this->session->userdata['tableName'])) {
            $this->session->unset_userdata('tableName');
        }
        $formName = $this->session->userdata('formName');
        $formType = 'Old';
        $this->_validateSelectTable();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Select View Table - ".$formName;
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("forms/selecttablevalidate");
            $data['table'] = $this->_selectTableTable();
            $data['backLink'] = anchor('forms/addcolumnold/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            $tableName = $this->input->post("tableNameDD");
            $this->session->set_userdata('tableName', $tableName);
            redirect('forms/addcolumnold');
        }
    }

    function _selectTableTable() {
        $this->load->model('formmodel');
        $tableNameDDA = $this->formmodel->getTableList("");
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $tableNameDD = form_dropdown('tableNameDD', $tableNameDDA);
        $submitButton = form_button($submitButtonA);
        $tableNameDDErr = form_error('tableNameDD');
        $formTableA = array(array(), array('Select Form : ', $tableNameDD, $tableNameDDErr), array('',
                           '<p style="text-align:center;">'.$submitButton.'</p>'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateSelectTable() {
        $this->form_validation->set_rules('tableNameDD', 'Table Name', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function selectcolumntype() {
        //after the addcolumn page
        //select the type of column to be added
        $formName = $this->session->userdata('formName');
        $formType = $this->session->userdata('formType');
        $this->table->set_empty("&nbsp;");
        if ($formType == 'Old') {
            $this->table->add_row(anchor('addoldcolumns/textform/',
                                 'Simple textbox with text, integer or decimal values without limits', array('class' =>
                                 'add')));
            $this->table->add_row(anchor('addoldcolumns/limitform/', 'Simple textbox with numeric value with limits',
                                 array('class' => 'add')));
            $this->table->add_row(anchor('addoldcolumns/userdropdown/', 'Add User dropdown', array('class' => 'add')));
            $data['backLink'] = anchor('forms/addcolumnold/', 'Back', array('class' => 'back'));
        }
        else {
            $this->table->add_row(anchor('formtypes/textform/',
                                 'Simple textbox with text, integer or decimal values without limits', array('class' =>
                                 'add')));
            $this->table->add_row(anchor('formtypes/limitform/', 'Simple textbox with numeric value with limits', array(
                                 'class' => 'add')));
            $this->table->add_row(anchor('formtypes/userdropdown/', 'Add User dropdown', array('class' => 'add')));
            $this->table->add_row(anchor('formtypes/twotextform/', 'Simple textbox with a prefix value', array('class'
                                 => 'add')));
            $data['backLink'] = anchor('forms/addcolumn/', 'Back', array('class' => 'back'));
        }
        $data['table'] = $this->table->generate();
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Select a Column Type - ".$formName;
        $data['formHeading'] = "";
        $this->load->view('forms/selectcolumntype', $data);
    }

    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }

    function deleteColumn($type = 'column', $dataEntryConfigID) {
        $formName = $this->session->userdata('formName');
        $formType = $this->session->userdata('formType');
        $this->configmodel->deleteColumn($dataEntryConfigID);
        $this->_resetColumnNumbers($formName, $formType, $type);
        if ($formType == 'Old') {
            redirect('forms/addcolumnold');
        }
        else {
            redirect('forms/addcolumn');
        }
    }

    function _resetColumnNumbers($formName, $formType, $type) {
        global $databaseName;
        if ($type == 'filter') {
            $plotColumnQuery = $this->configmodel->getFilterDataByFormName($databaseName, $formName, $formType);
        }
        else {
            $plotColumnQuery = $this->configmodel->getNoFilterDataByFormName($databaseName, $formName, $formType);
        }
        $plotColumnCount = $plotColumnQuery->num_rows();
        $i = 1;
        if ($plotColumnCount > 0) {
            foreach ($plotColumnQuery->result() as $plotColumnRow) {
                $this->configmodel->resetColumnNumber($plotColumnRow->DataEntryConfig_ID, $i);
                $i++;
            }
        }
    }

    function sortlist($type = 'New') {
        if (!isset ($this->session->userdata['formName']) || !isset ($this->session->userdata['formType'])) {
            redirect('forms/formtype');
        }
        $formName = $this->session->userdata('formName');
        $formType = $this->session->userdata('formType');
        global $databaseName;
        $plotColumnQuery = $this->configmodel->getNoFilterDataByFormName($databaseName, $formName, $formType);
        if ($plotColumnQuery->num_rows() > 0) {
            $sortList = "<ul>";
            $plotColumnResult = $plotColumnQuery->result();
            foreach ($plotColumnResult as $plotColumnRow) {
                $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
                $attributesArray = explode("\t", $plotColumnRow->Attributes);
                $columnHeader = $attributesArray[0];
                $sortList = $sortList.'<li id="recordsArray_'.$dataEntryConfigID.'">'.$plotColumnRow->ColumnNumber.". ".
                $columnHeader.'</li>';
            }
            $sortList = $sortList."</ul>";
        }
        else {
            $sortList = 'No Columns Added Yet. Please Click "Add a New Column" First.';
        }
        $data['list'] = $sortList;
        $data['button'] = '<p><input type="button" value="Update" onclick="updateList()"/></p>';
        if ($type == 'old') {
            $data['backLink'] = anchor('forms/addcolumnold/', 'Back', array('class' => 'back'));
        }
        else {
            $data['backLink'] = anchor('forms/addcolumn/', 'Back', array('class' => 'back'));
        }
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Sort Column List - ".$formName;
        $data['formHeading'] = "";
        $data['formOpen'] = form_open('forms/updatesortinglist');
        $this->load->view('forms/sortlist', $data);
    }

    function sortfilter() {
        if (!isset ($this->session->userdata['formName']) || !isset ($this->session->userdata['formType'])) {
            redirect('forms/formtype');
        }
        $formName = $this->session->userdata('formName');
        $formType = $this->session->userdata('formType');
        global $databaseName;
        $plotColumnQuery = $this->configmodel->getFilterDataByFormName($databaseName, $formName, $formType);
        if ($plotColumnQuery->num_rows() > 0) {
            $sortList = "<ul>";
            $plotColumnResult = $plotColumnQuery->result();
            foreach ($plotColumnResult as $plotColumnRow) {
                $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
                $attributesArray = explode("\t", $plotColumnRow->Attributes);
                $columnHeader = $attributesArray[0];
                $sortList = $sortList.'<li id="recordsArray_'.$dataEntryConfigID.'">'.$plotColumnRow->ColumnNumber.". ".
                $columnHeader.'</li>';
            }
            $sortList = $sortList."</ul>";
        }
        else {
            $sortList = 'No Columns Added Yet. Please Click "Add a New Column" First.';
        }
        $data['list'] = $sortList;
        $data['button'] = '<p><input type="button" value="Update" onclick="updateList()"/></p>';
        $data['backLink'] = anchor('forms/addcolumnold/', 'Back', array('class' => 'back'));
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Sort Filter - ".$formName;
        $data['formHeading'] = "";
        $data['formOpen'] = form_open('forms/updatesortinglist');
        $this->load->view('forms/sortlist', $data);
    }

    function updatesortlist() {
        $updateRecordsArray = $_POST['recordsArray'];
        $listingCounter = 1;
        foreach ($updateRecordsArray as $dataEntryConfigID) {
            $this->configmodel->resetColumnNumber($dataEntryConfigID, $listingCounter);
            $listingCounter = $listingCounter + 1;
        }
        $color = $this->_randomcolor();
        echo '<span style="color:#'.$color.'; font-size:medium;">List Updated!!</span>';
    }

    function _randomcolor() {
        mt_srand((double) microtime() * 1000000);
        $c = '';
        while (strlen($c) < 6) {
            $c .= sprintf("%02X", mt_rand(0, 200));
        }
        return $c;
    }

    function createconfigfile() {
        global $databaseName;
        $formName = $this->session->userdata('formName');
        $formType = $this->session->userdata('formType');
        if ($formType == 'Old') {
            $tableName = $this->session->userdata['tableName'];
            $fileName = $formName."_".$databaseName."_".$tableName;
            $backLink = anchor('forms/addcolumnold/', 'Back', array('class' => 'back'));
        }
        else {
            $fileName = $formName."_".$databaseName;
            $backLink = anchor('forms/addcolumn/', 'Back', array('class' => 'back'));
        }
        $plotColumnQuery = $this->configmodel->getDataByFormName($databaseName, $formName, $formType);
        if ($plotColumnQuery->num_rows() > 0) {
            $this->load->helper('file');
            $fileName = str_replace(" ", "", $fileName);
            $header = join('$', array("ColumnNumber", "ColumnType", "Attributes"));
            $nextline = "\r\n";
            write_file('./files/configfiles/'.$fileName.'.txt', $header, 'w+');
            write_file('./files/configfiles/'.$fileName.'.txt', $nextline, 'a');
            $plotColumnResult = $plotColumnQuery->result();
            foreach ($plotColumnResult as $plotColumnRow) {
                $dataRow = join('$', array($plotColumnRow->ColumnNumber, $plotColumnRow->ColumnType, $plotColumnRow->
                               Attributes));
                write_file('./files/configfiles/'.$fileName.'.txt', $dataRow, 'a');
                write_file('./files/configfiles/'.$fileName.'.txt', $nextline, 'a');
            }
        }
        $data['text'] = '<div class="success">Config File Created.</div>';
        $data['backLink'] = $backLink;
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "File Created - ".$formName;
        $data['formHeading'] = "";
        $this->load->view('forms/simpletext', $data);
    }

    function createdoubleconfigfile() {
        global $databaseName;
        $formName = $this->session->userdata('formName');
        $formType = $this->session->userdata('formType');
        if ($formType == 'Old') {
            $tableName = $this->session->userdata['tableName'];
            $backLink = anchor('forms/addcolumnold/', 'Back', array('class' => 'back'));
        }
        else {
            $backLink = anchor('forms/addcolumn/', 'Back', array('class' => 'back'));
        }
        $plotColumnQuery = $this->configmodel->getDataByFormName($databaseName, $formName, $formType);
        for ($x = 1; $x <= 2; $x++) {
            if ($plotColumnQuery->num_rows() > 0) {
                $this->load->helper('file');
                if ($formType == 'Old') {
                    $fileName = $formName.$x."_".$databaseName."_".$tableName;
                }
                else {
                    $fileName = $formName.$x."_".$databaseName;
                }
                $fileName = str_replace(" ", "", $fileName);
                $header = join('$', array("ColumnNumber", "ColumnType", "Attributes"));
                $nextline = "\r\n";
                write_file('./files/configfiles/'.$fileName.'.txt', $header, 'w+');
                write_file('./files/configfiles/'.$fileName.'.txt', $nextline, 'a');
                $plotColumnResult = $plotColumnQuery->result();
                foreach ($plotColumnResult as $plotColumnRow) {
                    $dataRow = join('$', array($plotColumnRow->ColumnNumber, $plotColumnRow->ColumnType, $plotColumnRow->
                                   Attributes));
                    write_file('./files/configfiles/'.$fileName.'.txt', $dataRow, 'a');
                    write_file('./files/configfiles/'.$fileName.'.txt', $nextline, 'a');
                }
            }
        }
        $data['text'] = '<div class="success">Config Files Created.</div>';
        $data['backLink'] = $backLink;
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "File Created - ".$formName;
        $data['formHeading'] = "";
        $this->load->view('forms/simpletext', $data);
    }

}
