<?php

class Formtypes extends Controller {

    function Formtypes() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->model('configmodel');
    }

    //////////////////Simple textbox with text,integer or decimal values with no limits///////////////////
    function textform() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Simple Text Form";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("formtypes/textformvalidate");
        $data['table'] = $this->_textFormTable();
        $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function textformvalidate() {
        $this->_validatetextform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Simple Text Form";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("formtypes/textformvalidate");
            $data['table'] = $this->_textFormTable();
            $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            //$plotID = $this->session->userdata('configPlotID');
            $formName = $this->session->userdata('formName');
            $formType = $this->session->userdata('formType');
            $columnType = "text";
            $columnNumber = $this->configmodel->getColumnNumber($formName, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $dataType = $this->input->post('dataType');
            $stemChange = $this->input->post('stemChange');
            $treeChange = $this->input->post('treeChange');
            $defaultValue = $this->input->post('defaultValue');
            $columnSize = $this->input->post('columnSize');
            $allowNull = $this->input->post('allowNull');
            $nextLineKey = $this->input->post('nextLineKey');
            $attributes = join("\t", array($columnHeader, $columnName, $dataType, $stemChange, $treeChange, $defaultValue,
                              $columnSize, $allowNull, $nextLineKey));
            $this->configmodel->insertFormData($formName, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _textFormTable() {
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $dataType = set_value('dataType');
        $stemChange = set_value('stemChange');
        $treeChange = set_value('treeChange');
        $defaultValue = set_value('defaultValue');
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName);
        $dataTypeA = array('default' => 'Select', 'varchar' => 'varchar', 'integer' => 'integer', 'float' => 'float',
                          'decimal' => 'decimal');
        $stemChangeA = array('no' => 'No', 'incremented' => 'Incremented', 'carried' => 'Carried Over');
        $treeChangeA = array('no' => 'No', 'incremented' => 'Incremented', 'carried' => 'Carried Over');
        $defaultValueA = array('name' => 'defaultValue', 'id' => 'defaultValue', 'size' => '16', 'value' => $defaultValue
                              );
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $allowNullA = array('no' => 'No', 'yes' => 'Yes');
        $nextLineKeyA = array('no' => 'No', 'yes' => 'Yes');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $dataTypeDD = form_dropdown('dataType', $dataTypeA);
        $stemChangeDD = form_dropdown('stemChange', $stemChangeA);
        $treeChangeDD = form_dropdown('treeChange', $treeChangeA);
        $defaultValueTbx = form_input($defaultValueA);
        $columnSizeTbx = form_input($columnSizeA);
        $allowNullDD = form_dropdown('allowNull', $allowNullA, 'yes');
        $nextLineKeyDD = form_dropdown('nextLineKey', $nextLineKeyA, 'no');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $dataTypeErr = form_error('dataType');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx, $columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx, $columnNameErr), array('Data Type : ', $dataTypeDD, $dataTypeErr
                           ), array('Is Value Changed with `+` : ', $stemChangeDD), array(
                           'Is Value Changed with `Enter` : ', $treeChangeDD), array('Default Value : ', $defaultValueTbx
                           ), array('Column Size : ', $columnSizeTbx, $columnSizeErr), array('Null Value Allowed: ', $allowNullDD
                           ), array('Add Next Row Stroke: ', $nextLineKeyDD), array(), array('', $submitButton."\t".$resetButton
                           ));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatetextform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    //////////////******************///////////////////////
    //////Simple text box with interger values and a limit check//////////
    function limitform() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Limit Form";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("formtypes/limitformvalidate");
        $data['table'] = $this->_limitFormTable();
        $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function limitformvalidate() {
        $this->_validatelimitform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Simple Text Form";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("formtypes/limitformvalidate");
            $data['table'] = $this->_limitFormTable();
            $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            //$plotID = $this->session->userdata('configPlotID');
            $formName = $this->session->userdata('formName');
            $formType = $this->session->userdata('formType');
            $columnType = "limit";
            $columnNumber = $this->configmodel->getColumnNumber($formName, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $dataType = $this->input->post('dataType');
            $stemChange = $this->input->post('stemChange');
            $treeChange = $this->input->post('treeChange');
            $upperLimit = $this->input->post('upperLimit');
            $lowerLimit = $this->input->post('lowerLimit');
            $defaultValue = $this->input->post('defaultValue');
            $columnSize = $this->input->post('columnSize');
            $allowNull = $this->input->post('allowNull');
            $nextLineKey = $this->input->post('nextLineKey');
            $attributes = join("\t", array($columnHeader, $columnName, $dataType, $stemChange, $treeChange, $upperLimit,
                              $lowerLimit, $defaultValue, $columnSize, $allowNull, $nextLineKey));
            $this->configmodel->insertFormData($formName, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _limitFormTable() {
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $dataType = set_value('dataType');
        $stemChange = set_value('stemChange');
        $treeChange = set_value('treeChange');
        $upperLimit = set_value('upperLimit');
        $lowerLimit = set_value('lowerLimit');
        $defaultValue = set_value('defaultValue');
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName);
        $dataTypeA = array('default' => 'Select', 'integer' => 'integer', 'float' => 'float', 'decimal' => 'decimal');
        $stemChangeA = array('no' => 'No', 'incremented' => 'Incremented', 'carried' => 'Carried Over');
        $treeChangeA = array('no' => 'No', 'incremented' => 'Incremented', 'carried' => 'Carried Over');
        $upperLimitA = array('name' => 'upperLimit', 'id' => 'upperLimit', 'size' => '16', 'value' => $upperLimit);
        $lowerLimitA = array('name' => 'lowerLimit', 'id' => 'lowerLimit', 'size' => '16', 'value' => $lowerLimit);
        $defaultValueA = array('name' => 'defaultValue', 'id' => 'defaultValue', 'size' => '16', 'value' => $defaultValue
                              );
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $allowNullA = array('no' => 'No', 'yes' => 'Yes');
        $nextLineKeyA = array('no' => 'No', 'yes' => 'Yes');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $dataTypeDD = form_dropdown('dataType', $dataTypeA);
        $stemChangeDD = form_dropdown('stemChange', $stemChangeA);
        $treeChangeDD = form_dropdown('treeChange', $treeChangeA);
        $defaultValueTbx = form_input($defaultValueA);
        $upperLimitTbx = form_input($upperLimitA);
        $lowerLimitTbx = form_input($lowerLimitA);
        $columnSizeTbx = form_input($columnSizeA);
        $allowNullDD = form_dropdown('allowNull', $allowNullA, 'yes');
        $nextLineKeyDD = form_dropdown('nextLineKey', $nextLineKeyA, 'no');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $dataTypeErr = form_error('dataType');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx, $columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx, $columnNameErr), array('Data Type : ', $dataTypeDD, $dataTypeErr
                           ), array('Is Value Changed with `+` : ', $stemChangeDD), array(
                           'Is Value Changed with `Enter` : ', $treeChangeDD), array('Upper Limit : ', $upperLimitTbx),
                           array('Lower Limit : ', $lowerLimitTbx), array('Default Value : ', $defaultValueTbx), array(
                           'Column Size : ', $columnSizeTbx, $columnSizeErr), array('Null Value Allowed: ', $allowNullDD
                           ), array('Add Next Row Stroke: ', $nextLineKeyDD), array(), array('', $submitButton."\t".$resetButton
                           ));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatelimitform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ////////////*******************///////////////////////
    ////////////User Dropdown/////////////////////////
    function userdropdown() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "User Dropdown";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("formtypes/userdropdownvalidate");
        $data['table'] = $this->_userFormTable();
        $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function userdropdownvalidate() {
        $this->_validateuserqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "User Dropdown";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("formtypes/userdropdownvalidate");
            $data['table'] = $this->_userFormTable();
            $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $formName = $this->session->userdata('formName');
            $formType = $this->session->userdata('formType');
            $columnType = "userdd";
            $columnNumber = $this->configmodel->getColumnNumber($formName, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $userData = $this->input->post('userData');
            $stemChange = $this->input->post('stemChange');
            $treeChange = $this->input->post('treeChange');
            $nextLineKey = $this->input->post('nextLineKey');
            $attributes = join("\t", array($columnHeader, $columnName, $userData, $stemChange, $treeChange, $nextLineKey
                              ));
            $this->configmodel->insertFormData($formName, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _userFormTable() {
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $userData = set_value('userData');
        $stemChange = set_value('stemChange');
        $treeChange = set_value('treeChange');
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName);
        $userDataA = array('name' => 'userData', 'id' => 'userData', 'value' => $userData, 'class' => 'textarea1');
        $stemChangeA = array('no' => 'No', 'carried' => 'Carried Over');
        $treeChangeA = array('no' => 'No', 'carried' => 'Carried Over');
        $nextLineKeyA = array('no' => 'No', 'yes' => 'Yes');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $userDataTarea = form_textarea($userDataA);
        $stemChangeDD = form_dropdown('stemChange', $stemChangeA, 'no');
        $treeChangeDD = form_dropdown('treeChange', $treeChangeA, 'no');
        $nextLineKeyDD = form_dropdown('nextLineKey', $nextLineKeyA, 'no');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $userDataErr = form_error('userData');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx.$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx.$columnNameErr), array('Is Value Changed with `+` : ', $stemChangeDD
                           ), array('Is Value Changed with `Enter` : ', $treeChangeDD), array('Add Next Row Stroke: ', $nextLineKeyDD
                           ), array('User Data : ', $userDataTarea), array('',
                           "Enter Dropdown options, separated by ; (Example: a;b;c)"), array('', $userDataErr), array(),
                           array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateuserqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('userData', 'User Data', 'required');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    //////////////////////////////////////////////////////////////////////////
    /////////////////twotextform////////////////////////////
    function twotextform() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Two Text Form";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("formtypes/twotextformvalidate");
        $data['table'] = $this->_twotextFormTable();
        $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function twotextformvalidate() {
        $this->_validatetwotextform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Two Text Form";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("formtypes/twotextformvalidate");
            $data['table'] = $this->_twotextFormTable();
            $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            //$plotID = $this->session->userdata('configPlotID');
            $formName = $this->session->userdata('formName');
            $formType = $this->session->userdata('formType');
            $columnType = "twotext";
            $columnNumber = $this->configmodel->getColumnNumber($formName, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $dataType = $this->input->post('dataType');
            $stemChange = $this->input->post('stemChange');
            $treeChange = $this->input->post('treeChange');
            $prefix = $this->input->post('prefix');
            $defaultValue = $this->input->post('defaultValue');
            $columnSize = $this->input->post('columnSize');
            $allowNull = $this->input->post('allowNull');
            $nextLineKey = $this->input->post('nextLineKey');
            $attributes = join("\t", array($columnHeader, $columnName, $dataType, $stemChange, $treeChange, $prefix, $defaultValue,
                              $columnSize, $allowNull, $nextLineKey));
            $this->configmodel->insertFormData($formName, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _twotextFormTable() {
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $dataType = set_value('dataType');
        $stemChange = set_value('stemChange');
        $treeChange = set_value('treeChange');
        $prefix = set_value('prefix');
        $defaultValue = set_value('defaultValue');
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName);
        $dataTypeA = array('default' => 'Select', 'varchar' => 'varchar', 'integer' => 'integer', 'float' => 'float',
                          'decimal' => 'decimal');
        $stemChangeA = array('no' => 'No', 'incremented' => 'Incremented', 'carried' => 'Carried Over');
        $treeChangeA = array('no' => 'No', 'incremented' => 'Incremented', 'carried' => 'Carried Over');
        $prefixA = array('name' => 'prefix', 'id' => 'prefix', 'size' => '16', 'value' => $prefix);
        $defaultValueA = array('name' => 'defaultValue', 'id' => 'defaultValue', 'size' => '16', 'value' => $defaultValue
                              );
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $allowNullA = array('no' => 'No', 'yes' => 'Yes');
        $nextLineKeyA = array('no' => 'No', 'yes' => 'Yes');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $dataTypeDD = form_dropdown('dataType', $dataTypeA);
        $stemChangeDD = form_dropdown('stemChange', $stemChangeA);
        $treeChangeDD = form_dropdown('treeChange', $treeChangeA);
        $prefixTbx = form_input($prefixA);
        $defaultValueTbx = form_input($defaultValueA);
        $columnSizeTbx = form_input($columnSizeA);
        $allowNullDD = form_dropdown('allowNull', $allowNullA, 'yes');
        $nextLineKeyDD = form_dropdown('nextLineKey', $nextLineKeyA, 'no');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $dataTypeErr = form_error('dataType');
        $columnSizeErr = form_error('columnSize');
        $prefixErr = form_error('prefix');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx, $columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx, $columnNameErr), array('Data Type : ', $dataTypeDD, $dataTypeErr
                           ), array('Is Value Changed with `+` : ', $stemChangeDD), array(
                           'Is Value Changed with `Enter` : ', $treeChangeDD), array('Prefix : ', $prefixTbx, $prefixErr
                           ), array('Default Value : ', $defaultValueTbx), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array('Null Value Allowed: ', $allowNullDD), array('Add Next Row Stroke: ', $nextLineKeyDD
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatetwotextform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_rules('prefix', 'Prefix', 'trim|required');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    /////////////////////////////////////////////////////////////////////////
    ///////////////Helper Functions///////////////////////
    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }
    ///////////////////////////////////////////////////////

}
