<?php
if (!defined('BASEPATH'))
    exit ('No direct script access allowed');

class Gdelibrary {

    function processData($formDetailResult) {
        foreach ($formDetailResult as $formDetailRow) {
            if ($formDetailRow->ColumnType == 'text') {
                $columnDetailA = $this->_textAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $columnDataTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['dataType'];
            }
            elseif ($formDetailRow->ColumnType == 'limit') {
                $columnDetailA = $this->_limitAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $columnDataTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['dataType'];
            }
            elseif ($formDetailRow->ColumnType == 'userdd') {
                $columnDetailA = $this->_userDDAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $columnDataTypeA[$formDetailRow->ColumnNumber] = "varchar";
            }
            elseif ($formDetailRow->ColumnType == 'twotext') {
                $columnDetailA = $this->_twotextAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $columnDataTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['dataType'];
            }
        }
        $processData['headerListA'] = $headerListA;
        $processData['columnNameA'] = $columnNameA;
        $processData['columnTypeA'] = $columnTypeA;
        $processData['columnDataTypeA'] = $columnDataTypeA;
        return $processData;
    }

    function _textAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['stemChange'] = $attributeA[3];
        $array ['treeChange'] = $attributeA[4];
        $array ['defaultValue'] = $attributeA[5];
        $array ['columnSize'] = $attributeA[6];
        $array ['allowNull'] = $attributeA[7];
        $array ['nextLineKey'] = $attributeA[8];
        return $array;
    }

    function _limitAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['stemChange'] = $attributeA[3];
        $array ['treeChange'] = $attributeA[4];
        $array ['upperLimit'] = $attributeA[5];
        $array ['lowerLimit'] = $attributeA[6];
        $array ['defaultValue'] = $attributeA[7];
        $array ['columnSize'] = $attributeA[8];
        $array ['allowNull'] = $attributeA[9];
        $array ['nextLineKey'] = $attributeA[10];
        return $array;
    }

    function _userDDAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['userData'] = $attributeA[2];
        if (isset ($attributeA[4]))
            //stemChange added later - for config file back compatibility
            {
            $array ['stemChange'] = $attributeA[3];
            $array ['treeChange'] = $attributeA[4];
            $array ['nextLineKey'] = $attributeA[5];
        }
        else {
            $array ['nextLineKey'] = $attributeA[3];
        }
        return $array;
    }

    function _twotextAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['stemChange'] = $attributeA[3];
        $array ['treeChange'] = $attributeA[4];
        $array ['prefix'] = $attributeA[5];
        $array ['defaultValue'] = $attributeA[6];
        $array ['columnSize'] = $attributeA[7];
        $array ['allowNull'] = $attributeA[8];
        $array ['nextLineKey'] = $attributeA[9];
        return $array;
    }

}
