<?php

class Configmodel extends Model {

    function Configmodel() {
        parent :: Model();
        //$database = $this->session->userdata('databaseName');
        $this->configdb = $this->load->database('db1', TRUE);
    }

    function getDataByFormName($databaseName, $formName, $formType) {
        $this->configdb->select('*');
        $this->configdb->from('DataEntryConfig');
        $this->configdb->where('DatabaseName', $databaseName);
        $this->configdb->where('FormName', $formName);
        $this->configdb->where('FormType', $formType);
        $this->configdb->order_by('ColumnNumber asc');
        $query = $this->configdb->get();
        return $query;
    }

    function getFilterDataByFormName($databaseName, $formName, $formType) {
        $this->configdb->select('*');
        $this->configdb->from('DataEntryConfig');
        $this->configdb->where('DatabaseName', $databaseName);
        $this->configdb->where('FormName', $formName);
        $this->configdb->where('FormType', $formType);
        $this->configdb->where('ColumnType', 'Filter');
        $this->configdb->order_by('ColumnNumber asc');
        $query = $this->configdb->get();
        return $query;
    }

    function getNoFilterDataByFormName($databaseName, $formName, $formType) {
        $this->configdb->select('*');
        $this->configdb->from('DataEntryConfig');
        $this->configdb->where('DatabaseName', $databaseName);
        $this->configdb->where('FormName', $formName);
        $this->configdb->where('FormType', $formType);
        $this->configdb->where('ColumnType !=', 'Filter');
        $this->configdb->order_by('ColumnNumber asc');
        $query = $this->configdb->get();
        return $query;
    }

    function getColumnNumber($formName, $formType) {
        $databaseName = $this->session->userdata('selectedPlotName');
        $this->configdb->select_max('ColumnNumber');
        //$this->configdb->where('Plots_ID',$plotID);
        $this->configdb->where('DatabaseName', $databaseName);
        $this->configdb->where('FormName', $formName);
        $this->configdb->where('FormType', $formType);
        $this->configdb->where('ColumnType !=', 'Filter');
        $query = $this->configdb->get('DataEntryConfig');
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $columnNumber = $row->ColumnNumber;
            $columnNumber = $columnNumber + 1;
        }
        else {
            $columnNumber = 1;
        }
        return $columnNumber;
    }

    function getColumnNumberFilter($formName, $formType) {
        $databaseName = $this->session->userdata('selectedPlotName');
        $this->configdb->select_max('ColumnNumber');
        //$this->configdb->where('Plots_ID',$plotID);
        $this->configdb->where('DatabaseName', $databaseName);
        $this->configdb->where('FormName', $formName);
        $this->configdb->where('FormType', $formType);
        $this->configdb->where('ColumnType', 'Filter');
        $query = $this->configdb->get('DataEntryConfig');
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $columnNumber = $row->ColumnNumber;
            $columnNumber = $columnNumber + 1;
        }
        else {
            $columnNumber = 1;
        }
        return $columnNumber;
    }

    function insertFormData($formName, $columnNumber, $columnType, $attributes) {
        $databaseName = $this->session->userdata('selectedPlotName');
        $insertArray = array('DatabaseName' => $databaseName, 'FormName' => $formName, 'ColumnNumber' => $columnNumber,
                            'ColumnType' => $columnType, 'Attributes' => $attributes);
        $this->configdb->insert('DataEntryConfig', $insertArray);
    }

    function insertFormDataOld($formType, $tableName, $formName, $columnNumber, $columnType, $attributes) {
        $databaseName = $this->session->userdata('selectedPlotName');
        $insertArray = array('DatabaseName' => $databaseName, 'FormType' => $formType, 'TableName' => $tableName,
                            'FormName' => $formName, 'ColumnNumber' => $columnNumber, 'ColumnType' => $columnType,
                            'Attributes' => $attributes);
        $this->configdb->insert('DataEntryConfig', $insertArray);
    }

    function checkFormName($formName, $databaseName) {
        $this->configdb->select('*');
        $this->configdb->from('DataEntryConfig');
        $this->configdb->where('FormName', $formName);
        $this->configdb->where('DatabaseName', $databaseName);
        $query = $this->configdb->get('');
        if ($query->num_rows() > 0) {
            $row = $query->row();
            $formType = $row->FormType;
        }
        else {
            $formType = 'No';
        }
        return $formType;
    }

    function getFormNameList($databaseName, $formType) {
        $list['default'] = 'Select';
        $this->configdb->distinct('FormName');
        $this->configdb->from('DataEntryConfig');
        $this->configdb->where('DatabaseName', $databaseName);
        $this->configdb->where('FormType', $formType);
        $this->configdb->order_by('FormName asc');
        $query = $this->configdb->get();
        if ($query->num_rows > 0) {
            foreach ($query->result() as $row) {
                $list[$row->FormName] = $row->FormName;
            }
        }
        return $list;
    }

    function resetColumnNumber($dataEntryConfigID, $i) {
        $data = array('ColumnNumber' => $i);
        $this->configdb->where('DataEntryConfig_ID', $dataEntryConfigID);
        $this->configdb->update('DataEntryConfig', $data);
    }

    function deleteColumn($dataEntryConfigID) {
        $this->configdb->where('DataEntryConfig_ID', $dataEntryConfigID);
        $this->configdb->delete('DataEntryConfig');
    }

}
